## dpdk 23.11.4

=== examples/l2fwd-crypto/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2010-2014 Intel Corporation

# binary name
APP = l2fwd-crypto

# all source are stored in SRCS-y
SRCS-y := main.c

PKGCONF ?= pkg-config

# Build using pkg-config variables if possible
ifneq ($(shell $(PKGCONF) --exists libdpdk && echo 0),0)
$(error "no installation of DPDK found")
endif

all: shared
.PHONY: shared static
shared: build/$(APP)-shared
	ln -sf $(APP)-shared build/$(APP)
static: build/$(APP)-static
	ln -sf $(APP)-static build/$(APP)

PC_FILE := $(shell $(PKGCONF) --path libdpdk 2>/dev/null)
CFLAGS += -O3 $(shell $(PKGCONF) --cflags libdpdk)
LDFLAGS_SHARED = $(shell $(PKGCONF) --libs libdpdk)
LDFLAGS_STATIC = $(shell $(PKGCONF) --static --libs libdpdk)

ifeq ($(MAKECMDGOALS),static)
# check for broken pkg-config
ifeq ($(shell echo $(LDFLAGS_STATIC) | grep 'whole-archive.*l:lib.*no-whole-archive'),)
$(warning "pkg-config output list does not contain drivers between 'whole-archive'/'no-whole-archive' flags.")
$(error "Cannot generate statically-linked binaries with this version of pkg-config")
endif
endif

CFLAGS += -DALLOW_EXPERIMENTAL_API
CONFIG_DEFINES = $(shell $(CC) $(CFLAGS) -dM -E - < /dev/null)
ifneq ($(findstring RTE_CRYPTO_SCHEDULER,$(CONFIG_DEFINES)),)
LDFLAGS_SHARED += -lrte_crypto_scheduler
endif

build/$(APP)-shared: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_SHARED)

build/$(APP)-static: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_STATIC)

build:
	@mkdir -p $@

.PHONY: clean
clean:
	rm -f build/$(APP) build/$(APP)-static build/$(APP)-shared
	test -d build && rmdir -p build || true

=== debian/changelog ===
dpdk (23.11.4-0ubuntu0.24.04.2) noble-security; urgency=medium

  * SECURITY UPDATE: DoS and info disclosure in mlx5
    - debian/patches/CVE-2025-23259.patch: fix out-of-order completions in
      ordinary Rx burst in drivers/net/mlx5/linux/mlx5_verbs.c,
      drivers/net/mlx5/mlx5_devx.c, drivers/net/mlx5/mlx5_ethdev.c,
      drivers/net/mlx5/mlx5_rx.c, drivers/net/mlx5/mlx5_rx.h,
      drivers/net/mlx5/mlx5_rxq.c.
    - CVE-2025-23259

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 07 Oct 2025 08:56:16 -0400

dpdk (23.11.4-0ubuntu0.24.04.1) noble; urgency=medium

  * Merge LTS stable release 23.11.4 (LP: #2067480)
    - Full release notes are available at:
      https://doc.dpdk.org/guides-23.11/rel_notes/release_23_11.html#id9

 -- Arif Ali <arif.ali@canonical.com>  Tue, 06 May 2025 06:56:35 +0000

dpdk (23.11.2-0ubuntu0.24.04.1) noble; urgency=medium

  * Merge LTS stable release 23.11.2 (LP: #2067480)
    - Full release notes are available at:
      https://doc.dpdk.org/guides-23.11/rel_notes/release_23_11.html#id1

  * Included changes from Debian unstable:
    [ Luca Bocassi ]
    - d/librte-c*-cnxk24.symbols: Update symbols files for internal
      symbols removals.

 -- Miriam España Acebal <miriam.espana@canonical.com>  Tue, 03 Sep 2024 12:38:11 +0200

=== debian/control ===
Source: dpdk
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian DPDK Maintainers <pkg-dpdk-devel@lists.alioth.debian.org>
Uploaders: Luca Boccassi <bluca@debian.org>,
           Christian Ehrhardt <christian.ehrhardt@canonical.com>,
           Santiago Ruano Rincón <santiagorr@riseup.net>,
Build-Depends: chrpath,
               debhelper-compat (= 13),
               dh-python,
               libbpf-dev,
               libbsd-dev,
               libelf-dev,
               libfdt-dev,
               libibverbs-dev (>= 23~),
               libipsec-mb-dev [amd64],
               libisal-dev [amd64],
               libjansson-dev,
               libmnl-dev,
               libnuma-dev,
               libpcap-dev,
               libssl-dev,
               libxdp-dev,
               meson (>= 0.47.1~),
               pkg-config,
               python3:any,
               python3-pyelftools,
               zlib1g-dev,
Build-Depends-Indep:
               doxygen <!nodoc>,
               graphviz <!nodoc>,
               inkscape <!nodoc>,
               python3-sphinx <!nodoc>,
               python3-sphinx-rtd-theme <!nodoc>,
               texlive-fonts-recommended <!nodoc>,
               texlive-latex-extra <!nodoc>,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Section: libs
Homepage: https://www.dpdk.org
Vcs-Git: https://salsa.debian.org/debian/dpdk.git -b unstable
Vcs-Browser: https://salsa.debian.org/debian/dpdk

Package: dpdk
Section: admin
Architecture: amd64 arm64 ppc64el riscv64
Depends: pci.ids | hwdata,
         pciutils,
         procps,
         ${misc:Depends},
         ${python3:Depends},
# Recommend a subset of more tested, more used and more supported libs
Recommends: librte-mempool24,
            librte-mempool-ring24,
            librte-net-af-packet24,
            librte-net-bond24,
            librte-net-e1000-24,
            librte-net-fm10k24,
            librte-net-i40e24,
            librte-net-ixgbe24,
            librte-net-mlx4-24,
            librte-net-mlx5-24,
            librte-net-netvsc24,
            librte-net-pcap24,
            librte-net-tap24,
            librte-net-thunderx24,
            librte-net-vdev-netvsc24,
            librte-net-vhost24,
            librte-net-virtio24,
            librte-net-vmxnet3-24,
            python3-pyelftools,
Suggests: dpdk-doc,
          dpdk-kmods-dkms,
          librte-meta-baseband,
          librte-meta-bus,
          librte-meta-common,
          librte-meta-compress,
          librte-meta-crypto,
          librte-meta-dma,
          librte-meta-event,
          librte-meta-mempool,
          librte-meta-net,
          librte-meta-raw,
          librte-meta-allpmds,
Breaks: dpdk-dev (<< 18.11-4~),
Replaces: dpdk-dev (<< 18.11),
Description: Data Plane Development Kit (runtime)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime environment to run DPDK applications.

Package: librte-meta-baseband
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: ${librte:Baseband},
         ${misc:Depends},
Description: Data Plane Development Kit (baseband libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte baseband libraries.

Package: librte-meta-bus
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: ${librte:Bus},
         ${misc:Depends},
Description: Data Plane Development Kit (bus libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte bus libraries.

Package: librte-meta-common
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: ${librte:Common},
         ${misc:Depends},
Description: Data Plane Development Kit (common libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte common libraries.

Package: librte-meta-compress
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: ${librte:Compress},
         ${misc:Depends},
Description: Data Plane Development Kit (compress libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte compress libraries.

Package: librte-meta-crypto
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: ${librte:Crypto},
         ${misc:Depends},
Description: Data Plane Development Kit (crypto libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte crypto libraries.

Package: librte-meta-dma
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: ${librte:Dma},
         ${misc:Depends},
Description: Data Plane Development Kit (dma libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte dma libraries.

Package: librte-meta-event
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: ${librte:Event},
         ${misc:Depends},
Description: Data Plane Development Kit (event libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte event libraries.

Package: librte-meta-mempool
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: ${librte:Mempool},
         ${misc:Depends},
Description: Data Plane Development Kit (mempool libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte mempool libraries.

Package: librte-meta-net
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: ${librte:Net},
         ${misc:Depends},
Description: Data Plane Development Kit (net libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte net libraries.

Package: librte-meta-raw
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: ${librte:Raw},
         ${misc:Depends},
Description: Data Plane Development Kit (raw libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte raw libraries.

Package: librte-meta-allpmds
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: ${librte:Allpmds},
         ${misc:Depends},
Description: Data Plane Development Kit (all poll mode drivers)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all poll mode drivers produced by DPDK.

Package: librte-meta-all
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: ${librte:All},
         ${misc:Depends},
Description: Data Plane Development Kit (all sub-libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all librte libraries produced by DPDK.

Package: dpdk-dev
Section: oldlibs
Architecture: amd64 arm64 ppc64el riscv64
Breaks: dpdk (<< 18.11-4~),
Replaces: dpdk (<< 18.11-4),
Depends: libdpdk-dev (>= ${source:Version}),
         python3,
         ${misc:Depends},
         ${shlibs:Depends},
Description: Data Plane Development Kit (dev tools)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains tools useful to a developer and for dpdk self tests.

Package: dpdk-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Homepage: https://dpdk.org/doc/guides/index.html
Depends: fonts-font-awesome,
         fonts-lato,
         fonts-roboto-slab,
         libjs-jquery,
         libjs-underscore,
         python3:any,
         ${misc:Depends},
         ${python3:Depends},
Recommends: ${python3:Recommends},
Description: Data Plane Development Kit (documentation)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the complete set of documentation and guides.

Package: libdpdk-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: libbpf-dev,
         libbsd-dev,
         libibverbs-dev,
         libipsec-mb-dev [amd64],
         libisal-dev [amd64],
         libelf-dev,
         libfdt-dev,
         libjansson-dev,
         libmnl-dev,
         libnuma-dev,
         libpcap-dev,
         libssl-dev,
         libxdp-dev,
         zlib1g-dev,
         ${librte:All},
         ${misc:Depends},
Description: Data Plane Development Kit (basic development files)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the basic headers and library files required to
 build external applications which will also require at least SSE3 support
 when running.
 .
 libdpdk.pc: note that CFLAGS might contain an -march flag higher than typical
 baseline.
 This is required for a number of static inline functions in the public headers.

Package: librte-acl24
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Homepage: https://dpdk.org/doc/api/rte__acl_8h.html
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Conflicts: libdpdk0,
Description: Data Plane Development Kit (librte-acl runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte-acl.

Package: librte-baseband-acc24
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Homepage: https://doc.dpdk.org/guides/bbdevs/acc100.html
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Conflicts: libdpdk0,
Description: Data Plane Development Kit (librte-baseband-acc100 runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte-baseband-acc100.

Package: librte-baseband-fpga-5gnr-fec24
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Homepage: https://doc.dpdk.org/guides/bbdevs/fpga_5gnr_fec.html
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Conflicts: libdpdk0,
Description: Data Plane Development Kit (librte-baseband-fpga-5gnr-fec runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .

=== debian/watch ===
version=4
https://fast.dpdk.org/rel/dpdk-(23.11.*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## dpdk 24.11.1

=== examples/l2fwd-keepalive/ka-agent/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2016-2020 Intel Corporation

# binary name
APP = ka-agent

# all source are stored in SRCS-y
SRCS-y := main.c

CFLAGS += -I..

PKGCONF ?= pkg-config

# Build using pkg-config variables if possible
ifneq ($(shell $(PKGCONF) --exists libdpdk && echo 0),0)
$(error "no installation of DPDK found")
endif

all: shared
.PHONY: shared static
shared: build/$(APP)-shared
	ln -sf $(APP)-shared build/$(APP)
static: build/$(APP)-static
	ln -sf $(APP)-static build/$(APP)

LDFLAGS += -lpthread -lrt

PC_FILE := $(shell $(PKGCONF) --path libdpdk 2>/dev/null)
CFLAGS += -O3 $(shell $(PKGCONF) --cflags libdpdk)
LDFLAGS_SHARED = $(shell $(PKGCONF) --libs libdpdk)
LDFLAGS_STATIC = $(shell $(PKGCONF) --static --libs libdpdk)

ifeq ($(MAKECMDGOALS),static)
# check for broken pkg-config
ifeq ($(shell echo $(LDFLAGS_STATIC) | grep 'whole-archive.*l:lib.*no-whole-archive'),)
$(warning "pkg-config output list does not contain drivers between 'whole-archive'/'no-whole-archive' flags.")
$(error "Cannot generate statically-linked binaries with this version of pkg-config")
endif
endif

CFLAGS += -DALLOW_EXPERIMENTAL_API

build/$(APP)-shared: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_SHARED)

build/$(APP)-static: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_STATIC)

build:
	@mkdir -p $@

.PHONY: clean
clean:
	rm -f build/$(APP) build/$(APP)-static build/$(APP)-shared
	test -d build && rmdir -p build || true

=== debian/changelog ===
dpdk (24.11.1-1) unstable; urgency=high

  * New upstream release 24.11.1. For a full list of changes in 24.11.1 see:
    https://doc.dpdk.org/guides/rel_notes/release_24_11.html
    Fixes rx checksum calculation in virtio driver (CVE-2024-11614)

 -- Luca Boccassi <bluca@debian.org>  Tue, 17 Dec 2024 14:59:34 +0000

dpdk (24.11-2) unstable; urgency=medium

  * Upload to unstable

 -- Luca Boccassi <bluca@debian.org>  Mon, 16 Dec 2024 11:10:47 +0000

dpdk (24.11-1) experimental; urgency=medium

  * New upstream release 24.11. For a full list of changes in 24.11 see:
    https://doc.dpdk.org/guides/rel_notes/release_24_11.html

 -- Luca Boccassi <bluca@debian.org>  Sun, 01 Dec 2024 12:45:26 +0000

dpdk (24.11~rc4-1) experimental; urgency=medium

  * Update upstream source from tag 'upstream/24.11_rc4'
  * dpdk-doc: remove unreproducible generated files

 -- Luca Boccassi <bluca@debian.org>  Wed, 27 Nov 2024 10:27:28 +0000

dpdk (24.11~rc3-1) experimental; urgency=medium

  * Update upstream source from tag 'upstream/24.11_rc3'
  * Add new PMDs added in v24.11~rc3

 -- Luca Boccassi <bluca@debian.org>  Wed, 20 Nov 2024 23:24:00 +0000

dpdk (24.11~rc2-2) experimental; urgency=medium

  * Build new librte-power-* PMDs on all architectures

 -- Luca Boccassi <bluca@debian.org>  Thu, 14 Nov 2024 23:46:01 +0000

dpdk (24.11~rc2-1) experimental; urgency=medium

  [ Christian Ehrhardt ]
  * New upstream release candidate 24.11-rc1
    For a full list of changes in 24.11 see
    https://doc.dpdk.org/guides/rel_notes/release_24_11.html
    - Drop d/p/disable-parallel-sphinx.patch (upstream since v24.07-rc1)
    - Drop d/p/Fix-ppc64-test-via-iova-setting.patch (upstream since v24.07-rc1)
    - d/*.symbols: rename and update to match the ABI change to 25
    - d/control: Bump lib package names to 24.11 ABI
    - d/copyright: update for updsteam and debian/* changes
    - d/watch: move to 24.11 LTS
    - d/control, d/dpdk{-dev}.install: add new and move existing telemetry
      files to dpdk
    - d/control: add new libraries librte-net-ntnic25, librte-dma-odm25,
      librte-crypto-ionic25, librte-compress-nitrox25, librte-common-nitrox25,
      librte-common-ionic25, librte-bus-uacce25. librte-argparse25
    - d/control: drop breaks to libdpdk0 (no more needed)
    - d/*.symbols: adapt to match changes to exported symbols
    - d/*.symbols: symbols files for new libs
    - d/p/*.patch: change Forwarded: no to not-needed
    - d/README.source: maintainer hint to compare binary pkg content
    - d/control: librte-net-mana25 also builds on amd64 now

  [ Luca Boccassi ]
  * gbp.conf: switch upstream branch and tag
  * Update upstream source from tag 'upstream/24.11_rc2'
  * Add packages for new PMDs added in 24.11~rc2
  * Update symbols for 24.11~rc2
  * Add dependency on armv8crc-support on arm64 packages
  * Drop dependency on sse4.2-support from libdpdk-dev

 -- Luca Boccassi <bluca@debian.org>  Thu, 14 Nov 2024 14:21:02 +0000

dpdk (23.11.2-3) unstable; urgency=medium

  * Disable flaky test on riscv64

 -- Luca Boccassi <bluca@debian.org>  Thu, 07 Nov 2024 14:28:21 +0000

dpdk (23.11.2-2) unstable; urgency=medium

  * Upload to unstable

 -- Luca Boccassi <bluca@debian.org>  Sun, 20 Oct 2024 13:38:06 +0100

dpdk (23.11.2-1+exp4) experimental; urgency=medium

  * autopkgtest: fix meson setup in test-fastsuite

 -- Luca Boccassi <bluca@debian.org>  Sat, 19 Oct 2024 12:43:21 +0100

dpdk (23.11.2-1+exp3) experimental; urgency=medium

  * Fix patch disabling tests on ppc64el

 -- Luca Boccassi <bluca@debian.org>  Thu, 17 Oct 2024 17:29:58 +0100

dpdk (23.11.2-1+exp2) experimental; urgency=medium

  * Revert "autopkgtest: run ppc64_cpu --smt=off before test to avoid race
    condition"
  * autopkgtest: build with -Dplatform=generic to fix build failure in
    riscv64
  * Disable flaky tests on ppc64el

 -- Luca Boccassi <bluca@debian.org>  Thu, 17 Oct 2024 14:28:10 +0100

dpdk (23.11.2-1+exp1) experimental; urgency=medium

  * autopkgtest: run ppc64_cpu --smt=off before test to avoid race
    condition

 -- Luca Boccassi <bluca@debian.org>  Thu, 10 Oct 2024 15:04:09 +0100

dpdk (23.11.2-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/23.11.2'

 -- Luca Boccassi <bluca@debian.org>  Wed, 09 Oct 2024 18:57:38 +0100

=== debian/control ===
Source: dpdk
Priority: optional
Maintainer: Debian DPDK Maintainers <pkg-dpdk-devel@lists.alioth.debian.org>
Uploaders: Luca Boccassi <bluca@debian.org>,
           Christian Ehrhardt <christian.ehrhardt@canonical.com>,
           Santiago Ruano Rincón <santiagorr@riseup.net>,
Build-Depends: chrpath,
               debhelper-compat (= 13),
               dh-package-notes,
               dh-python,
               libbpf-dev,
               libbsd-dev,
               libelf-dev,
               libfdt-dev,
               libibverbs-dev (>= 23~),
               libipsec-mb-dev [amd64],
               libisal-dev [amd64],
               libjansson-dev,
               libmnl-dev,
               libnuma-dev,
               libpcap-dev,
               libssl-dev,
               libxdp-dev,
               meson (>= 0.47.1~),
               pkgconf,
               python3:any,
               python3-pyelftools,
               zlib1g-dev,
Build-Depends-Indep:
               doxygen <!nodoc>,
               graphviz <!nodoc>,
               inkscape <!nodoc>,
               python3-sphinx <!nodoc>,
               python3-sphinx-rtd-theme <!nodoc>,
               texlive-fonts-recommended <!nodoc>,
               texlive-latex-extra <!nodoc>,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Section: libs
Homepage: https://www.dpdk.org
Vcs-Git: https://salsa.debian.org/debian/dpdk.git -b unstable
Vcs-Browser: https://salsa.debian.org/debian/dpdk

Package: dpdk
Section: admin
Architecture: amd64 arm64 ppc64el riscv64 loong64
Depends: pci.ids | hwdata,
         pciutils,
         procps,
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
         ${python3:Depends},
# Recommend a subset of more tested, more used and more supported libs
Recommends: librte-mempool25,
            librte-mempool-ring25,
            librte-net-af-packet25,
            librte-net-bond25,
            librte-net-e1000-25,
            librte-net-fm10k25,
            librte-net-i40e25,
            librte-net-ixgbe25,
            librte-net-mlx4-25,
            librte-net-mlx5-25,
            librte-net-netvsc25,
            librte-net-pcap25,
            librte-net-tap25,
            librte-net-thunderx25,
            librte-net-vdev-netvsc25,
            librte-net-vhost25,
            librte-net-virtio25,
            librte-net-vmxnet3-25,
            python3-pyelftools,
Suggests: dpdk-doc,
          dpdk-kmods-dkms,
          librte-meta-baseband,
          librte-meta-bus,
          librte-meta-common,
          librte-meta-compress,
          librte-meta-crypto,
          librte-meta-dma,
          librte-meta-event,
          librte-meta-mempool,
          librte-meta-net,
          librte-meta-raw,
          librte-meta-allpmds,
Breaks: dpdk-dev (<< 24.11~rc1-1),
Replaces: dpdk-dev (<< 24.11~rc1-1),
Description: Data Plane Development Kit (runtime)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime environment to run DPDK applications.

Package: librte-meta-baseband
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Baseband},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (baseband libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte baseband libraries.

Package: librte-meta-bus
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Bus},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (bus libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte bus libraries.

Package: librte-meta-common
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Common},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (common libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte common libraries.

Package: librte-meta-compress
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Compress},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (compress libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte compress libraries.

Package: librte-meta-crypto
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Crypto},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (crypto libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte crypto libraries.

Package: librte-meta-dma
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Dma},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (dma libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte dma libraries.

Package: librte-meta-event
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Event},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (event libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte event libraries.

Package: librte-meta-mempool
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Mempool},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (mempool libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte mempool libraries.

Package: librte-meta-net
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Net},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (net libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte net libraries.

Package: librte-meta-raw
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Raw},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (raw libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte raw libraries.

Package: librte-meta-allpmds
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Allpmds},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (all poll mode drivers)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all poll mode drivers produced by DPDK.

Package: librte-meta-all
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:All},
         ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (all sub-libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all librte libraries produced by DPDK.

Package: dpdk-dev
Section: oldlibs
Architecture: amd64 arm64 ppc64el riscv64 loong64
Breaks: dpdk (<< 24.11~rc1-1),
Depends: libdpdk-dev (>= ${source:Version}),
         python3,
         ${misc:Depends},
         ${shlibs:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
Description: Data Plane Development Kit (dev tools)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains tools useful to a developer and for dpdk self tests.

Package: dpdk-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Homepage: https://dpdk.org/doc/guides/index.html
Depends: fonts-font-awesome,
         fonts-lato,
         fonts-roboto-slab,
         libjs-jquery,
         libjs-underscore,
         python3:any,
         ${misc:Depends},
         ${python3:Depends},
Recommends: ${python3:Recommends},
Description: Data Plane Development Kit (documentation)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the complete set of documentation and guides.

Package: libdpdk-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: libbpf-dev,
         libbsd-dev,
         libibverbs-dev,
         libipsec-mb-dev [amd64],
         libisal-dev [amd64],
         libelf-dev,
         libfdt-dev,
         libjansson-dev,
         libmnl-dev,
         libnuma-dev,
         libpcap-dev,
         libssl-dev,
         libxdp-dev,
         zlib1g-dev,
         ${librte:All},
         ${misc:Depends},
Description: Data Plane Development Kit (basic development files)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the basic headers and library files required to
 build external applications which will also require at least SSE3 support
 when running.
 .
 libdpdk.pc: note that CFLAGS might contain an -march flag higher than typical
 baseline.
 This is required for a number of static inline functions in the public headers.

Package: librte-acl25
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Homepage: https://dpdk.org/doc/api/rte__acl_8h.html
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         sse4.2-support [amd64],
         armv8crc-support [arm64],
         ${shlibs:Depends},
Description: Data Plane Development Kit (librte-acl runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte-acl.

Package: librte-argparse25

=== debian/rules ===
#!/usr/bin/make -f

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+all
DEB_CFLAGS_MAINT_APPEND = -flto=auto -ffat-lto-objects
DEB_CXXFLAGS_MAINT_APPEND = -flto=auto -ffat-lto-objects
DEB_LDFLAGS_MAINT_APPEND = -flto=auto -ffat-lto-objects
include /usr/share/dpkg/default.mk
include /usr/share/debhelper/dh_package_notes/package-notes.mk

# Upstream now defines a single ABI across all libs that we will use
DPDK_ABI := $(shell cat ABI_VERSION | cut -d. -f1)
# Experimental libs will have 0.200 on actual ABI 20.0
DPDK_EXP_ABI := "0.$(shell cat ABI_VERSION | cut -d. -f1-2 | tr -d ".")"

#ifeq (,$(findstring terse,$(DEB_BUILD_OPTIONS)))
#	export DH_VERBOSE=1
#	export DH_OPTIONS=-v
#endif

# People rebuilding this package can overwrite RTE_PLATFORM
# via DEB_BUILD_OPTIONS if they like
ifneq (,$(filter rte_machine=%,$(DEB_BUILD_OPTIONS)))
	echo "WARNING: the machine setting is deprecated, please use platform (rte_platform)"
    RTE_PLATFORM ?= $(patsubst rte_machine=%,%,$(filter rte_platform=%,$(DEB_BUILD_OPTIONS)))
endif
ifneq (,$(filter rte_platform=%,$(DEB_BUILD_OPTIONS)))
    RTE_PLATFORM ?= $(patsubst rte_platform=%,%,$(filter rte_platform=%,$(DEB_BUILD_OPTIONS)))
endif
# default to minimal base, without setting this it would build
# -march=native which is a non portable invariant
RTE_PLATFORM ?= "generic"

ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
BUILD_DOCS=n
else
ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
BUILD_DOCS=n
# to stop dh_installdoc from running
export DEB_BUILD_PROFILES += nodoc
else
BUILD_DOCS=y
endif
endif

# Allow to pass specific configure flags to meson as a comma separated list
ifneq (,$(filter dpdk_config_options=%,$(DEB_BUILD_OPTIONS)))
# GNU Makefile hack: can't directly escape comma and spaces, so use variables
    comma := ,
    empty :=
    space := $(empty) $(empty)
    DPDK_CONFIG_OPTIONS ?= $(subst $(comma),$(space),$(patsubst dpdk_config_options=%,%,$(filter dpdk_config_options=%,$(DEB_BUILD_OPTIONS))))
endif

%:
	dh $@ --with python3 --buildsystem=meson

override_dh_gencontrol:
	dh_gencontrol
	# debian/files will not exist until dh_gencontrol has ran at least once,
	# so we need to run gencontrol for libdpdk-dev after.
	# The list of libraries and PMDs is everchanging, so generate the dependency
	# list for libdpdk-dev to avoid having to maintain it manually.
	# Various meta packages help users to gain a granular access per lib-subtype.
	# The recommends list for dpdk has more common libs, all full meta categories
	# are listed as suggests.
	dh_gencontrol -p libdpdk-dev          -- -V"librte:All=`grep      -E 'librte-*'           ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-all      -- -V"librte:All=`grep      -E 'librte-*'           ./debian/files | grep -v dbgsym | grep -v 'librte-meta-' | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-baseband -- -V"librte:Baseband=`grep -E 'librte-baseband-.*' ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-bus      -- -V"librte:Bus=`grep      -E 'librte-bus-.*'      ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-common   -- -V"librte:Common=`grep   -E 'librte-common-.*'   ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-compress -- -V"librte:Compress=`grep -E 'librte-compress-.*' ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-crypto   -- -V"librte:Crypto=`grep   -E 'librte-crypto-.*'   ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-dma      -- -V"librte:Dma=`grep      -E 'librte-dma-.*'      ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-event    -- -V"librte:Event=`grep    -E 'librte-event-.*'    ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-mempool  -- -V"librte:Mempool=`grep  -E 'librte-mempool-.*'  ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-net      -- -V"librte:Net=`grep      -E 'librte-net-.*'      ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-raw      -- -V"librte:Raw=`grep      -E 'librte-raw-.*'      ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-allpmds -- -V"librte:Allpmds=`for pmd in $$(find -type d -wholename './debian/librte-*dpdk/pmds-*'); do awk -v "ver=$(DEB_VERSION)" '/^Package:/ {printf("%s (= %s), \n",$$2,ver)}' "$${pmd}/../../../../../DEBIAN/control"; done | LC_ALL=C sort --stable | xargs`"

override_dh_auto_clean:
	rm -f doc/guides/compressdevs/overview_feature_table.txt \
		doc/guides/cryptodevs/overview_aead_table.txt \
		doc/guides/cryptodevs/overview_asym_table.txt \
		doc/guides/cryptodevs/overview_auth_table.txt \
		doc/guides/cryptodevs/overview_cipher_table.txt \
		doc/guides/cryptodevs/overview_feature_table.txt \
		doc/guides/nics/overview_table.txt \
		doc/guides/bbdevs/overview_feature_table.txt \
		doc/guides/cryptodevs/overview_os_table.txt \
		doc/guides/eventdevs/overview_crypto_adptr_feature_table.txt \
		doc/guides/eventdevs/overview_feature_table.txt \
		doc/guides/eventdevs/overview_rx_adptr_feature_table.txt \
		doc/guides/eventdevs/overview_timer_adptr_feature_table.txt \
		doc/guides/eventdevs/overview_tx_adptr_feature_table.txt \
		doc/guides/gpus/overview_feature_table.txt \
		doc/guides/nics/rte_flow_actions_table.txt \
		doc/guides/nics/rte_flow_items_table.txt \
		doc/guides/regexdevs/overview_feature_table.txt \
		doc/guides/vdpadevs/overview_feature_table.txt
	# test directory for sockets, etc
	rm -rf $(CURDIR)/tmpdir
	# every PMD package has a ldconfig-escape lintian warning, so we generate an override, delete them on cleanup
	find debian -type f \( -iname "librte-*.lintian-overrides" ! -iname "librte-meta*.lintian-overrides" \) -delete
	# some python helpers got precompiled in place along the way and are not always cleaned up
	find . -name '*.pyc' -type f -delete
	find . -name '__pycache__' -type d -delete
	dh_auto_clean

override_dh_auto_configure:
	dh_auto_configure -- $(DPDK_CONFIG_OPTIONS) \
		--includedir=include/dpdk \
		--default-library=shared \
		-Dinclude_subdir_arch=../$(DEB_HOST_MULTIARCH)/dpdk \
		-Dplatform=$(RTE_PLATFORM) \
		-Db_lto=true
	head obj-$(DEB_HOST_GNU_TYPE)/compile_commands.json || find . -name compile_commands.json
	grep --max-count=1 -e '-mcpu=' -e '-march=' \
		obj-$(DEB_HOST_GNU_TYPE)/compile_commands.json
	grep -q -e '-mcpu=power8' -e '-march=corei7' -e '-march=armv8-a+crc' -e '-march=rv64gc' -e '-march=loongarch64' \
		obj-$(DEB_HOST_GNU_TYPE)/compile_commands.json \
		|| (echo "Error: unexpected target cpu"; exit 1)

override_dh_auto_build-indep:
ifeq (y,$(BUILD_DOCS))
	dh_auto_build -- doc
